#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <conio.h>

#define MAX(x,y) ((x)<(y) ? (y) : (x))

//------------------------------------------------------------------------------
//  ESTRUTURAS PRINCIPAIS
//------------------------------------------------------------------------------

struct aulas
{
  char* dep;           //     Sigla do departamento
  int codigo;           //    Cdigo da aula
  int turma;           //     Turma
  char flag;           //      aula terica ou prtica (t ou p)
  int flag2[3];
  int demanda;           //    Demanda
  int dia[3];               //    dia da semana
  int horini[3];            //    Hora de inicio
  int horfim[3];           //     Hora de fim
  int horaini[3];        //       horrio da semana de inicio
  int horafim[3];        //       horrio da semana de fim
};

//------------------------------------------------------------------------------
//  VARIVEIS GLOBAIS
//------------------------------------------------------------------------------

double temperatura_inicial;
double temperatura_final;
int inviabilidade; //numero de inviabilidades da soluo encontrada
int pexcesso;     //penalidade por exceder a capacidade da sala
int pociosidade;   //penalidade por possuir cartieras vazias
int naula;       // nmero de aulas
int capacidade[8];     //armazena a capcidade das salas
aulas aula[100];
int tabelaS0 [91][8];     //tabela de alocao de salas - Soluo corrente
int tabelaS [91][8];     //tabela de alocao de salas - Soluo
int tabelaSstar [91][8];     //tabela de alocao de salas - Melhor Soluo obtida at ento
int nsalas= 7;          // nmero de salas
int nhorarios= 90;      //nmero de horrios
int fo;                //funo objetivo
int foS;
int foSstar;
int itermax;            // numero mximo de iteraes sem melhoria
double alfa;          // coeficiente de resfriamento
int SAmax;            // numero maximo de iteracoes em uma dada temperatura

//------------------------------------------------------------------------------
//DECLARAO DAS FUNES
//------------------------------------------------------------------------------

void sol_viavel();
void calcula_fo_ini();
void imprime_solstar();
void ler_peso();
int menu();
void le_entrada();
void sol_inicial();
void min_hour(int min, int &h, int &m);
char* legendadep (int valor);
int legendahor (int hora, int dia);
double randomico(int min, int max);
void imprime_sol();
void SA();
void calcula_foS();
void calcula_foSstar();

//------------------------------------------------------------------------------
//  Programa Principal
//------------------------------------------------------------------------------
void main()
{
   int seleciona;
   printf("--------------------------------------------------------------------------------");
   gotoxy(28,2);
   printf("PROBLEMA DE ALOCACAO DE SALAS\n");
   gotoxy(27,3);
   printf("- USANDO SIMULATED ANNEALING -\n");
   printf("--------------------------------------------------------------------------------");
   do
   {
      seleciona = menu();
      if (seleciona == 1)
      {
        /* Geracao aleatoria de uma solucao inicial */
        printf("Solucao inicial aleatoria:\n");
        le_entrada();
        sol_inicial();
        imprime_sol();
        printf("Funo Objetivo= %d\n", fo);
      }
      else
      {
        if  (seleciona == 2)
        {
          /* Simulated Annealing */
          if (fo != 0)
          {
            alfa = 0.9;
            SAmax = 5000;
            temperatura_inicial = 1000;
            temperatura_final = 0.01;
            itermax= 10000;
            SA();
            sol_viavel();
            imprime_solstar();
            printf("\n\nFuno Objetivo= %d\n", foSstar);
          }
          else
          {
               printf("\n ----- Gere uma solucao inicial -------\n");
               getchar();
          }
        }
      }

   }while (seleciona != 0);
}


//------------------------------------------------------------------------------
//  Funo Menu
//------------------------------------------------------------------------------

int menu()
{
  int escolha;

  do {
    printf("--------------------------------------------------------------------------------");
    printf("         0. Sair \n");
    printf("         1. Gere solucao inicial \n");
    printf("         2. Simulated Annealing \n");
    printf("         Escolha: ");
    scanf("%d",&escolha);
    printf("--------------------------------------------------------------------------------");
  }while (escolha < 0 || escolha > 2);
  return escolha;
}

//________________________________________________________________________
//FUNO TRANSFORMA MINUTO EM HORA
//________________________________________________________________________

void min_hour(int min, int &h, int &m)
{
	h = 0;
	m = 0;
	h = min/60;                          // transforma tempo em ninutos para formato hh:mm
	m = min%60;
	//if (h>=24) {h-=24;};

}

//------------------------------------------------------------------------------
//  Funo legenda dos departamentos
//------------------------------------------------------------------------------

char* legendadep (int digito)
{
  char* saida;
  switch (digito)
    {
       case 1:
          saida = "MTM";
          break;

       case 2:
          saida= "QUI";
          break;

       case 3:
          saida= "FIS";
          break;

       case 4:
          saida= "CIC";
          break;

       case 5:
          saida= "COM";
          break;

       case 6:
          saida= "CBI";
          break;
    }
    return saida;
}

//------------------------------------------------------------------------------
//  Funo legenda dos horrios
//------------------------------------------------------------------------------

int legendahor (int hora, int dia)
{
  int saida;

  if ((hora== 450) && (dia== 2)){saida= 1;}
  if ((hora== 500) && (dia== 2)){saida= 2;}
  if ((hora== 570) && (dia== 2)){saida= 3;}
  if ((hora== 620) && (dia== 2)){saida= 4;}
  if ((hora== 680) && (dia== 2)){saida= 5;}
  if ((hora== 730) && (dia== 2)){saida= 6;}
  if ((hora== 780) && (dia== 2)){saida= 7;}
  if ((hora== 830) && (dia== 2)){saida= 8;}
  if ((hora== 900) && (dia== 2)){saida= 9;}
  if ((hora== 950) && (dia== 2)){saida= 10;}
  if ((hora== 1010) && (dia== 2)){saida= 11;}
  if ((hora== 1060) && (dia== 2)){saida= 12;}
  if ((hora== 1110) && (dia== 2)){saida= 13;}
  if ((hora== 1140) && (dia== 2)){saida= 14;}
  if ((hora== 1190) && (dia== 2)){saida= 15;}
  if ((hora== 1260) && (dia== 2)){saida= 16;}
  if ((hora== 1310) && (dia== 2)){saida= 17;}

  if ((hora== 450) && (dia== 3)){saida= 18;}
  if ((hora== 500) && (dia== 3)){saida= 19;}
  if ((hora== 570) && (dia== 3)){saida= 20;}
  if ((hora== 620) && (dia== 3)){saida= 21;}
  if ((hora== 680) && (dia== 3)){saida= 22;}
  if ((hora== 730) && (dia== 3)){saida= 23;}
  if ((hora== 780) && (dia== 3)){saida= 24;}
  if ((hora== 830) && (dia== 3)){saida= 25;}
  if ((hora== 900) && (dia== 3)){saida= 26;}
  if ((hora== 950) && (dia== 3)){saida= 27;}
  if ((hora== 1010) && (dia== 3)){saida= 28;}
  if ((hora== 1060) && (dia== 3)){saida= 29;}
  if ((hora== 1110) && (dia== 3)){saida= 30;}
  if ((hora== 1140) && (dia== 3)){saida= 31;}
  if ((hora== 1190) && (dia== 3)){saida= 32;}
  if ((hora== 1260) && (dia== 3)){saida= 33;}
  if ((hora== 1310) && (dia== 3)){saida= 34;}

  if ((hora== 450) && (dia== 4)){saida= 35;}
  if ((hora== 500) && (dia== 4)){saida= 36;}
  if ((hora== 570) && (dia== 4)){saida= 37;}
  if ((hora== 620) && (dia== 4)){saida= 38;}
  if ((hora== 680) && (dia== 4)){saida= 39;}
  if ((hora== 730) && (dia== 4)){saida= 40;}
  if ((hora== 780) && (dia== 4)){saida= 41;}
  if ((hora== 830) && (dia== 4)){saida= 42;}
  if ((hora== 900) && (dia== 4)){saida= 43;}
  if ((hora== 950) && (dia== 4)){saida= 44;}
  if ((hora== 1010) && (dia== 4)){saida= 45;}
  if ((hora== 1060) && (dia== 4)){saida= 46;}
  if ((hora== 1110) && (dia== 4)){saida= 47;}
  if ((hora== 1140) && (dia== 4)){saida= 48;}
  if ((hora== 1190) && (dia== 4)){saida= 49;}
  if ((hora== 1260) && (dia== 4)){saida= 50;}
  if ((hora== 1310) && (dia== 4)){saida= 51;}

  if ((hora== 450) && (dia== 5)){saida= 52;}
  if ((hora== 500) && (dia== 5)){saida= 53;}
  if ((hora== 570) && (dia== 5)){saida= 54;}
  if ((hora== 620) && (dia== 5)){saida= 55;}
  if ((hora== 680) && (dia== 5)){saida= 56;}
  if ((hora== 730) && (dia== 5)){saida= 57;}
  if ((hora== 780) && (dia== 5)){saida= 58;}
  if ((hora== 830) && (dia== 5)){saida= 59;}
  if ((hora== 900) && (dia== 5)){saida= 60;}
  if ((hora== 950) && (dia== 5)){saida= 61;}
  if ((hora== 1010) && (dia== 5)){saida= 62;}
  if ((hora== 1060) && (dia== 5)){saida= 63;}
  if ((hora== 1110) && (dia== 5)){saida= 64;}
  if ((hora== 1140) && (dia== 5)){saida= 65;}
  if ((hora== 1190) && (dia== 5)){saida= 66;}
  if ((hora== 1260) && (dia== 5)){saida= 67;}
  if ((hora== 1310) && (dia== 5)){saida= 68;}

  if ((hora== 450) && (dia== 6)){saida= 69;}
  if ((hora== 500) && (dia== 6)){saida= 70;}
  if ((hora== 570) && (dia== 6)){saida= 71;}
  if ((hora== 620) && (dia== 6)){saida= 72;}
  if ((hora== 680) && (dia== 6)){saida= 73;}
  if ((hora== 730) && (dia== 6)){saida= 74;}
  if ((hora== 780) && (dia== 6)){saida= 75;}
  if ((hora== 830) && (dia== 6)){saida= 76;}
  if ((hora== 900) && (dia== 6)){saida= 77;}
  if ((hora== 950) && (dia== 6)){saida= 78;}
  if ((hora== 1010) && (dia== 6)){saida= 79;}
  if ((hora== 1060) && (dia== 6)){saida= 80;}
  if ((hora== 1110) && (dia== 6)){saida= 81;}
  if ((hora== 1140) && (dia== 6)){saida= 82;}
  if ((hora== 1190) && (dia== 6)){saida= 83;}
  if ((hora== 1260) && (dia== 6)){saida= 84;}
  if ((hora== 1310) && (dia== 6)){saida= 85;}

  if ((hora== 450) && (dia== 7)){saida= 86;}
  if ((hora== 500) && (dia== 7)){saida= 87;}
  if ((hora== 570) && (dia== 7)){saida= 88;}
  if ((hora== 620) && (dia== 7)){saida= 89;}
  if ((hora== 680) && (dia== 7)){saida= 90;}

  return saida;
}

//------------------------------------------------------------------------------
//  Funo retorno dos horrios
//------------------------------------------------------------------------------

/*int retornahor (int ent)
{
  int hora;
  int dia;
  if (ent== 1){hora= 450; dia= 2;}
  return hora;
  return dia;
} */

//------------------------------------------------------------------------------
//  Funo le dados de entrada
//------------------------------------------------------------------------------

void le_entrada()
{
  int i, k, valor;
  int codigo, turma, dia;
  char flag;
  char* dep;
  int h1, m1, h2, m2;

  FILE *cap;
	cap = fopen("capacidade.txt", "r");
	if(!cap)
	{
	  printf("\n\nArquivo capacidade.txt nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}

  FILE *dem;
	dem = fopen("demanda.txt", "r");
	if(!dem)
	{
	  printf("\n\nArquivo demanda.txt nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}

  FILE *hor;
	hor = fopen("horario.txt", "r");
	if(!hor)
	{
	  printf("\n\nArquivo horario.txt nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}

  FILE *dis;
	dis = fopen("disciplina.txt", "w");
	if(!dis)
	{
	  printf("\n\nArquivo disciplina.txt nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}


  i=0;
  while (!feof(cap))
  {
    fscanf(cap, "%d|%d|\n", &i, &valor);
    capacidade[i] = valor;
  }
  i=0;
  while (!feof(dem))
  {
    i++;
    fscanf(dem, "%d|%d|%d|%d|\n", &valor, &aula[i].codigo,
                                  &aula[i].turma, &aula[i].demanda);
    aula[i].dep = legendadep (valor);
    for (k=0; k<=2; k++)
    {
      aula[i].dia[k]=0;
      aula[i].horini[k]=0;
      aula[i].horfim[k]=0;
      aula[i].horaini[k]=0;
      aula[i].horafim[k]=0;
      aula[i].flag2[k] =0;
    }
  }
  naula= i;
  i=0;
  while (!feof(hor))
  {
    i++;
    fscanf(hor, "%d|%d|%d|%c|%d|%d:%d|%d:%d|\n", &valor, &codigo, &turma, &flag,
                                                 &dia, &h1, &m1, &h2, &m2);
    m1+= h1*60;
    m2+= h2*60;
    dep = legendadep(valor);
    for (i=1; i<=naula; i++)
    {
       if ((codigo== aula[i].codigo) && (turma== aula[i].turma) &&
            (dep== aula[i].dep))
       {
           aula[i].flag= flag;
           for(k=1; k<=2; k++)
           {
               if ((aula[i].dia[k]== 0) && (aula[i].dia[k-1]!=dia))
               {
                   aula[i].dia[k]= dia;
               }
               if (aula[i].dia[k]== dia)
               {
                   if (aula[i].horini[k]==0)
                   {
                       aula[i].horini[k]= m1;
                       aula[i].horfim[k]= m1;
                   }
                   else
                   {
                      if (m1<aula[i].horini[k])
                      {
                          aula[i].horini[k]= m1;
                      }
                      else
                      {
                          aula[i].horfim[k]= m1;
                      }
                   }
               }
           }
           break;
       }
    }
    for (i=1; i<=naula; i++)
    {
        for(k=1; k<=2; k++)
        {
           if (aula[i].dia[k]!= 0)
           {
              aula[i].horaini[k]= legendahor(aula[i].horini[k], aula[i].dia[k]);
              aula[i].horafim[k]= legendahor(aula[i].horfim[k], aula[i].dia[k]);
           }
        }

    }
  }
  fprintf(dis,"\n\n----------------------------------------------------------------------------\n");
  fprintf(dis,"| N. | Disciplina | Turma | Demanda | Horaini | Horafim | Horaini | Horafim |\n");
  fprintf(dis,"----------------------------------------------------------------------------\n");
  for (i=1; i<=naula; i++)
  {
        fprintf(dis,"| %2.2d |   %s%d   |  %2.2d   |   %2.2d    | ", i, aula[i].dep, aula[i].codigo,
                     aula[i].turma, aula[i].demanda);
        for(k=1; k<=2; k++)
        {
           fprintf(dis,"  %2.2d    |   %2.2d    | ", aula[i].horaini[k], aula[i].horafim[k]);
        }
        fprintf(dis,"\n");
        fprintf(dis,"----------------------------------------------------------------------------\n");
  }
  fclose(dis);
  fclose(hor);
  fclose(cap);
  fclose(dem);
}

//------------------------------------------------------------------------------
//  Funo gera nmero aleatrio
//------------------------------------------------------------------------------

double randomico(int min, int max)
{
  //if (min == max) {return min;}
  return ((double) (random(max-min) + min));
}


//------------------------------------------------------------------------------
//  Funo gera soluo inicial aleatria
//------------------------------------------------------------------------------

void sol_inicial()
{
     int n; //sala escolhida
     int m, ms;  //horrio da semana
     int i;  //aula
     int k= 1;  //horrio da aula
     int iter= 0; //numero de tentativas de alocar uma aula
     int aux;

     for (n=0; n<=nsalas; n++)
     {
        for (m=0; m<=nhorarios; m++)
        {
           tabelaS0[m][n]= 0;
        }
     }
     //escolhe uma aula
     for (i=1; i<= naula; i++)
     {
       for (k=1; k<= 2; k++)
       {
         //aleatoriamente escolhe uma sala
         aux= randomico(1, (nsalas+1));
         n= aux;
         iter=0;
         do
         {
            m= aula[i].horaini[k];
            ms= aula[i].horafim[k];
               if ((tabelaS0[m][n]== 0) && (tabelaS0[ms][n]== 0))
               {
                  tabelaS0[m][n]= i;
                  tabelaS0[ms][n]= i;
                  if ((ms-m)>1) {tabelaS0[ms-1][n]=i;}
                  if ((ms-m)>2) {tabelaS0[m+1][n]=i;}
                  aula[i].flag2[k]= 1;
                  break;
               }
               else
               {
                  aux= randomico(1, (nsalas+1));
                  n= aux;
                  if (iter>15)
                  {
                     tabelaS0[m][0]= i;
                     tabelaS0[ms][0]= i;
                     tabelaS0[ms-1][0]= i;
                     aula[i].flag2[k]= 1;
                     break;
                  }
                  iter++;
               }
          }while (aula[i].flag2[k]== 0);
       }
     }
     ler_peso();
     calcula_fo_ini();
}

//------------------------------------------------------------------------------
//  Funo imprime soluo inicial
//------------------------------------------------------------------------------

void imprime_sol()
{
    int m, n;

    FILE *sol;
	sol = fopen("solucao.txt", "w");
	if(!sol)
	{
	  printf("\n\nArquivo solucao.txt nao pode ser criado.\n");
	  getchar();
	  exit(1);
	}
    fprintf (sol, "\nFuno Objetivo: %d\n\n\n", fo);
    fprintf (sol, "_________________________________________________\n");
    fprintf (sol, "|H-S\t| sv | 01 | 02 | 03 | 04 | 05 | 06 | 07 |\n");
    fprintf (sol, "_________________________________________________\n");
    for (m= 1; m<=nhorarios; m++)
    {
        fprintf (sol, "| %d\t|", m);
        for (n=0; n<=nsalas; n++)
        {
           fprintf (sol, " %2.2d |", tabelaS0[m][n]);
        }
        fprintf (sol, "\n");
    }
    fprintf (sol, "_________________________________________________\n");

    fclose(sol);
}

//------------------------------------------------------------------------------
//  Funo imprime soluo final
//------------------------------------------------------------------------------

void imprime_solstar()
{
    int m, n;

    FILE *sol;
	sol = fopen("solucaof.txt", "w");
	if(!sol)
	{
	  printf("\n\nArquivo solucao.txt nao pode ser criado.\n");
	  getchar();
	  exit(1);
	}
    fprintf (sol, "\nFuno Objetivo: %d\n", foSstar);
    fprintf (sol, "Inviabilidades: %d\n", inviabilidade);
    fprintf (sol, "_________________________________________________\n");
    fprintf (sol, "|H-S\t| sv | 01 | 02 | 03 | 04 | 05 | 06 | 07 |\n");
    fprintf (sol, "_________________________________________________\n");
    for (m= 1; m<=nhorarios; m++)
    {
        fprintf (sol, "| %d\t|", m);
        for (n=0; n<=nsalas; n++)
        {
           fprintf (sol, " %2.2d |", tabelaSstar[m][n]);
        }
        fprintf (sol, "\n");
    }
    fprintf (sol, "_________________________________________________\n");

    fclose(sol);
}

//------------------------------------------------------------------------------
//  Funo le parametros de peso
//------------------------------------------------------------------------------

void ler_peso()
{
        int aux;

	FILE *pes;
	pes = fopen("peso.par", "r");
	if(!pes)
	{
	  //clrscr();
	  printf("\n\nArquivo nsuica.par nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}

	fscanf(pes, "%d", &aux);
	pexcesso= aux;
	fscanf(pes, "%d", &aux);
	pociosidade= aux;
        printf("Penalidade por excesso de capacidade= %d\nPenalidade por ociosidade= %d\n",
                                                        pexcesso, pociosidade);
	fclose(pes);
}

//------------------------------------------------------------------------------
//  Funo calcula funo objetivo inicial
//------------------------------------------------------------------------------

void calcula_fo_ini()
{
    int m, n; //dimenses da tabelaS0 de alocao de salas
    int aux;

    fo= 0;
    for (m= 1; m<=nhorarios; m++)
    {
        for (n=0; n<=nsalas; n++)
        {
            aux= tabelaS0[m][n];
            if (aula[aux].demanda> capacidade[n])
            {
                   fo+= pexcesso*(aula[aux].demanda- capacidade[n]);
            }
            else
            {
                   fo+= pociosidade*(capacidade[n]- aula[aux].demanda);
            }
        }
    }
    //printf("Funo Objetivo= %d\n", fo);
}

//------------------------------------------------------------------------------
//  Funo calcula FOS
//------------------------------------------------------------------------------

void calcula_foS()
{
    int m, n; //dimenses da tabelaS0 de alocao de salas
    int aux;

    foS= 0;
    for (m= 1; m<=nhorarios; m++)
    {
        for (n=0; n<=nsalas; n++)
        {
            aux= tabelaS[m][n];
            if (aula[aux].demanda> capacidade[n])
            {
                   foS+= pexcesso*(aula[aux].demanda- capacidade[n]);
            }
            else
            {
                   foS+= pociosidade*(capacidade[n]- aula[aux].demanda);
            }
        }
    }
}

//------------------------------------------------------------------------------
//  Funo calcula FOSstar
//------------------------------------------------------------------------------

void calcula_foSstar()
{
    int m, n; //dimenses da tabelaS0 de alocao de salas
    int aux;

    foSstar= 0;
    for (m= 1; m<=nhorarios; m++)
    {
        for (n=0; n<=nsalas; n++)
        {
            aux= tabelaSstar[m][n];
            if (aula[aux].demanda> capacidade[n])
            {
                   foSstar+= pexcesso*(aula[aux].demanda- capacidade[n]);
            }
            else
            {
                   foSstar+= pociosidade*(capacidade[n]- aula[aux].demanda);
            }
        }
    }
}

//------------------------------------------------------------------------------
//  Funo Simulated Annealing
//------------------------------------------------------------------------------

void SA()
{
    double temperatura;
    double delta;   // variao da energia
    double x;        //nmero randomico
    int m, n; //dimenses da tabela
    int iter; //nmero de iteraes
    int aux, i, j; //contadores auxiliares
    int posicao[6]; //identifca aulas duplas
    int pare, pare1, pare2;//para os loops quando no existe melhoras na fostar

    for (m= 1; m<=nhorarios; m++)
    {
        for (n=0; n<=nsalas; n++)
        {
            tabelaS[m][n]= tabelaS0[m][n];
            tabelaSstar [m][n]= tabelaS[m][n];
        }
    }
    calcula_foSstar();
    temperatura= temperatura_inicial;

    pare2= 0;
    while (temperatura > temperatura_final)
    {
       iter = 0;
       pare1= 0;
       while (iter < SAmax) // enquanto o equilibrio termico nao for atingido
       {
          iter++;
	  // escolha um vizinho qualquer
          for (j=0; j<6; j++)
          {
              posicao[j]=0;     // limpa o vetor que identifica as aulas sequenciais
          }
          do
          {
             aux= randomico(0, (nsalas+1));
             n= aux;
             aux= randomico(1, (nhorarios+1));
             m= aux;
          }while (tabelaS[m][n]==0);
          j= 0;
          for (i= (m-3); i<=(m+3); i++)
          {
             if (tabelaS[m][n]== tabelaS[i][n])
             {
                posicao[j]= i;    // identifica as aulas sequenciais
                j++;
             }
          }

          pare= 0;
          do
          {
            aux= randomico(0, (nsalas+1));
            //printf("|");
            if (tabelaS[m][aux]== 0)
            {
               //printf(" %d\n", pare1);
               pare1++;
               pare2++;
               if (pare1> (0.1*itermax))
               {
                   break;      // encerrar o SA quando ocorre mais de itermax iteraes sem melhora
               }
               if ((((tabelaS[(posicao[0])][n]!= 0) && (tabelaS[(posicao[0])][aux]==0)) ||(tabelaS[(posicao[0])][n]== 0))
                  && (((tabelaS[(posicao[1])][n]!= 0) && (tabelaS[(posicao[1])][aux]==0)) ||(tabelaS[(posicao[1])][n]== 0))
                  && (((tabelaS[(posicao[2])][n]!= 0) && (tabelaS[(posicao[2])][aux]==0)) ||(tabelaS[(posicao[2])][n]== 0))
                  && (((tabelaS[(posicao[3])][n]!= 0) && (tabelaS[(posicao[3])][aux]==0)) ||(tabelaS[(posicao[3])][n]== 0))
                  && (((tabelaS[(posicao[4])][n]!= 0) && (tabelaS[(posicao[4])][aux]==0)) ||(tabelaS[(posicao[4])][n]== 0))
                  && (((tabelaS[(posicao[5])][n]!= 0) && (tabelaS[(posicao[5])][aux]==0)) ||(tabelaS[(posicao[5])][n]== 0)))
               {
                  tabelaS[m][aux]= tabelaS[m][n];
                  tabelaS[m][n]= 0;
                  pare= 1;
                  for (j= 0; j<=5; j++)
                  {
                    if (tabelaS[(posicao[j])][n]!= 0)
                    {
                       tabelaS[(posicao[j])][aux]= tabelaS[(posicao[j])][n];
                       tabelaS[(posicao[j])][n]= 0;
                    }
                  }
               }
            }
          }while (pare!=1);
          calcula_foS();
          delta= foS - fo;
          if (delta<0)
          {
             printf("\n\nNovo vizinho funo objetivo: %d\n", foS);
             printf("Temperatura atual: %f\n", temperatura);
             printf("Numero de iteraes: %d\n", iter);
             for (m= 1; m<=nhorarios; m++)
             {
                 for (n=0; n<=nsalas; n++)
                 {
                     tabelaS0[m][n]= tabelaS[m][n];
                 }
             }
             if (foS<foSstar)
             {
                 for (m= 1; m<=nhorarios; m++)
                 {
                     for (n=0; n<=nsalas; n++)
                     {
                         tabelaSstar[m][n]= tabelaS[m][n];
                     }
                 }
                 calcula_foSstar();
                 pare1=0;
                 pare2=0;
                 printf("\n\nNova funo objetivo: %d\n", foSstar);
                 printf("Temperatura atual: %f\n", temperatura);
                 printf("Numero de iteraes: %d\n", iter);
             }
          }
          else
          {
             x= randomico(0,100000);
             x= x/100000;
             if (x< (exp(-delta/temperatura)))
             {
                calcula_foS();
                printf("\n\nNovo vizinho funo objetivo: %d\n", foS);
                printf("Temperatura atual: %f\n", temperatura);
                printf("Numero de iteraes: %d\n", iter);
                for (m= 1; m<=nhorarios; m++)
                {
                    for (n=0; n<=nsalas; n++)
                    {
                      tabelaS0[m][n]= tabelaS[m][n];
                    }
                }
             }
          }
          for (m= 1; m<=nhorarios; m++)
          {
            for (n=0; n<=nsalas; n++)
            {
              tabelaS[m][n]= tabelaS0[m][n];
            }
          }
          calcula_fo_ini();
          if (pare1> (0.1*itermax))
          {
             break;    // encerrar o SA quando ocorre mais de itermax iteraes sem melhora
          }
       }
       if (pare2> (itermax))
       {
          break;     // encerrar o SA quando ocorre mais de itermax iteraes sem melhora
       }
       temperatura = alfa*temperatura;
    }
}

//------------------------------------------------------------------------------
//  Funo confere soluo vivel
//------------------------------------------------------------------------------

void sol_viavel()
{
  int i, m, n;

  inviabilidade=0;
  printf("\n");
  for (n=0; n<=nsalas; n++)
  {
     for (m= 1; m<=nhorarios; m++)
     {
        i= tabelaSstar[m][n];
        if (aula[i].demanda> capacidade[n])
        {
           inviabilidade++;
           printf("%d - ",i);
        }
     }
  }
  printf("\nnumero de inviabilidades: %d \n", inviabilidade);
} 
